#include<iostream>
#include<vector>
using namespace std;
const int MAX_N=1e4+2;
const int MAX_M=5e4+2;
int n,m;
struct Edges
{
    int x;
    int y;
};
Edges e[MAX_M];
int used[MAX_M];
int sz[MAX_N];
int parent[MAX_N];
int Find(int u)
{
    if(parent[u]==u)return u;
    else return parent[u]=Find(parent[u]);
}
void Merge(int u,int v)
{
    int u_root=Find(u);
    int v_root=Find(v);
    if(sz[u_root]>sz[v_root])swap(u_root,v_root);
    parent[u_root]=v_root;
    sz[v_root]+=sz[u_root];
}
void Read()
{
    cin>>n>>m;
    int ed;
    for(int i=1;i<=m;i++)
    {
        cin>>e[i].x>>e[i].y;
    }
    for(int i=1;i<n;i++)
    {
        sz[i]=1;
        parent[i]=i;
        cin>>ed;
        used[ed]=1;
    }
    sz[n]=1;
    parent[n]=n;
}
vector<int>ans;
int cnt;
void Get_tree()
{
    for(int i=1;i<=m;i++)
    {
        if(used[i]==1)continue;
        int u=e[i].x;
        int v=e[i].y;
        if(Find(u)!=Find(v))
        {
            cnt++;
            Merge(u,v);
            used[i]=2;
            ans.push_back(i);
        }
    }
    cout<<cnt<<endl;
    if(cnt<n-1)
    {
        for(int i=1;i<=m;i++)
        {
            if(used[i]==2)continue;
            int u=e[i].x;
            int v=e[i].y;
            if(Find(u)!=Find(v))
            {
                cnt++;
                Merge(u,v);
                ans.push_back(i);
                //used[i]=2;
            }
        }
    }
    cout<<ans[0];
    for(int i=1;i<n-1;i++)
    {
        cout<<" "<<ans[i];
    }
    cout<<endl;
}
int main ()
{
    Read();
    Get_tree();









    return 0;
}

