#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;

struct str
{
    long long ind;
    long long u;
    long long v;
    long long t;
};

const long long MAXN = 1e6 + 2;
long long n, m, dsu[MAXN], sz[MAXN], brswaps = 0;
vector <str> a;
vector <long long> otg;

bool cmp (str x, str y)
{
    if (x.t <= y.t) return true;
    return false;
}

void Read()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    long long x, y;
    cin >> n >> m;
    for (long long i=1; i<=m; i++)
    {
        cin >> x >> y;
        dsu[x] = x;
        dsu[y] = y;
        sz[x] = 1;
        sz[y] = 1;
        a.push_back({i, x, y, 0});
    }
    for (long long i=1; i<n; i++)
    {
        cin >> x;
        a[x - 1].t = 1;
    }
    sort(a.begin(), a.end(), cmp);
    return ;
}

long long Find(long long k)
{
    if (dsu[k] == k) return k;
    else return dsu[k] = Find(dsu[k]);
}

void Connect(long long x, long long y)
{
    long long bx = Find(x);
    long long by = Find(y);

    if (sz[bx] > sz[by]) swap(bx, by);
    dsu[bx] = by;
    sz[by] += sz[bx];
}

int main()
{
    Read();
    for (long long i=0; i<m; i++)
    {
        if (Find(a[i].u) != Find(a[i].v))
        {
            Connect(a[i].u, a[i].v);
            if (a[i].t == 0) brswaps++;
            otg.push_back(a[i].ind);
        }
    }
    cout << brswaps << endl;
    sort(otg.begin(), otg.end());
    for (long long i=0; i<otg.size(); i++)
    {
        cout << otg[i] << " ";
    }cout << endl;
    return 0;
}
