#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const int maxn = 1e4 + 10, maxm = 5e4 + 10;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

struct edge
{
    int v, u, cost, idx;
}e[maxm];

bool cmp(edge e1, edge e2)
{
    return e1.cost < e2.cost;
}

int n, m, p[maxn];

int find_leader(int i)
{
    if (i == p[i])
        return i;
    return (p[i] = find_leader(p[i]));
}

bool unite(int i, int j)
{
    i = find_leader(i);
    j = find_leader(j);
    if (i == j)
        return false;
    p[i] = j;
    return true;
}
void solve()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i ++)
        cin >> e[i].v >> e[i].u, e[i].cost = 0, e[i].idx = i;
    for (int i = 1; i < n; i ++)
    {
        int x;
        cin >> x;
        e[x].cost = 1;
    }

    sort(e + 1, e + m + 1, cmp);

    for (int i = 1; i <= n; i ++)
        p[i] = i;

    int cnt = 0, ans = 0;
    vector < int > path;
    for (int i = 1; i <= m && cnt < n - 1; i ++)
    {
        if (unite(e[i].v, e[i].u))
        {
            ans = ans + 1 - e[i].cost;
            path.push_back(e[i].idx);
            cnt ++;
        }
    }

    cout << ans << endl;
    for (int i = 0; i < n - 1; i ++)
        cout << path[i] << " ";
    cout << endl;
}

int main()
{
    speed();
    solve();
    return 0;
}
