#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;

struct str
{
    int ind;
    int u;
    int v;
    int t;
};

const int MAXN = 1e8 + 2;
int n, m, dsu[MAXN], sz[MAXN], brswaps = 0, tree[MAXN];
vector <str> a;
vector <str> aa;
vector <int> otg;

bool cmp (str x, str y)
{
    if (x.t <= y.t) return true;
    else return false;
}

void Sort()
{
    for (int i=0; i<a.size(); i++)
    {
        if (a[i].t == 0) aa.push_back(a[i]);
    }
    for (int i=0; i<a.size(); i++)
    {
        if (a[i].t == 1) aa.push_back(a[i]);
    }
}

void Read()
{
    int x, y;
    cin >> n >> m;
    for (int i=1; i<=m; i++)
    {
        cin >> x >> y;
        dsu[x] = x;
        dsu[y] = y;
        sz[x] = 1;
        sz[y] = 1;
        a.push_back({i, x, y, 0});
    }
    for (int i=1; i<n; i++)
    {
        cin >> x;
        a[x - 1].t = 1;
    }
    Sort();
    return ;
}

int Find(int k)
{
    if (dsu[k] == k) return k;
    else return dsu[k] = Find(dsu[k]);
}

void Connect(int x, int y)
{
    int bx = Find(x);
    int by = Find(y);

    if (sz[bx] > sz[by]) swap(bx, by);
    dsu[bx] = by;
    sz[by] += sz[bx];
}

int main()
{
    Read();
    for (int i=0; i<m; i++)
    {
        if (Find(aa[i].u) != Find(aa[i].v))
        {
            Connect(aa[i].u, aa[i].v);
            if (aa[i].t == 0) brswaps++;
            otg.push_back(aa[i].ind);
        }
    }
    cout << brswaps << endl;
    sort(otg.begin(), otg.end());
    for (int i=0; i<otg.size(); i++)
    {
        cout << otg[i] << " ";
    }cout << endl;
    return 0;
}
