#include <bits/stdc++.h>

const int MAX_N=10000;

int n, m;

std::vector<std::pair<int, int>> v;
std::vector<int> nbrs[MAX_N];

bool use[MAX_N][MAX_N];

int parent[MAX_N];

int nums[MAX_N][MAX_N];

bool viz[MAX_N];

void par( int p, int ch ){
    viz[p]=true;
    for( int j : nbrs[ch] ){
        if( p!=j and !viz[j] and use[ch][j] ){
            parent[j]=ch;
            par( ch, j );
        }
    }
    return;
}

bool u[MAX_N];

int main () {

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);

    std::cin>>n>>m;
    for( int i=0 ; i<m ; i++ ){
        int a, b;
        std::cin>>a>>b;
        a--;
        b--;
        //if( b>a ) std::swap(a, b);
        v.push_back({a, b});
        nums[a][b]=i;
        nums[b][a]=i;
        nbrs[a].push_back(b);
        nbrs[b].push_back(a);
    }
    for( int i=0 ; i<n-1 ; i++ ){
        int curr;
        std::cin>>curr;
        curr--;
        u[curr]=true;
        //std::cerr<<v[curr].second<<" "<<v[curr].first<<"\n";
        use[v[curr].second][v[curr].first]=true;
        use[v[curr].first][v[curr].second]=true;
    }
    par(0, 0);

    /*
    for( int i=0 ; i<n ; i++ ){
        std::cerr<<i<<" "<<parent[i]<<"\n";
    }
*/
    for( int i=1 ; i<n ; i++ ){
        for( auto j : nbrs[i] ){
            if( parent[j]!=i and !use[i][j] ){
                parent[i]=j;
                /*
                use[i][j]=true;
                use[j][i]=true;
                */
                break;
            }
        }
    }

    /*std::cerr<<"\n----------\n";
    for( int i=0 ; i<n ; i++ ){
        std::cerr<<i<<" "<<parent[i]<<"\n";
    }
*/
    int ans=0;
    for( int i=1 ; i<n ; i++ )
        if(!u[nums[i][parent[i]]])ans++;

    std::cout<<ans<<"\n";
    for( int i=1 ; i<n ; i++ )
        std::cout<<nums[i][parent[i]]+1<<" ";

    return 0;
}
